"use server";
import { prisma, Prisma } from "@repo/db";
import bcrypt from "bcryptjs";
import { sendMailByTemplate } from "../../../../helper/mail";

export const editUser = async (id: string, data: Prisma.UserUpdateInput) => {
	return await prisma.user.update({
		where: {
			id: id,
		},
		data,
	});
};

export const resetPassword = async (id: string) => {
	const array = new Uint8Array(8);
	crypto.getRandomValues(array);
	const password = Array.from(array, (byte) => ("0" + (byte % 36).toString(36)).slice(-1)).join("");
	const hashedPassword = await bcrypt.hash(password, 12);

	const user = await prisma.user.update({
		where: {
			id: id,
		},
		data: {
			password: hashedPassword,
		},
	});

	await sendMailByTemplate(user.email, "password-change", {
		user: user,
		password: password,
	});

	return { password };
};

export const deleteDispoHistory = async (id: number) => {
	return await prisma.connectedDispatcher.delete({
		where: {
			id: id,
		},
	});
};

export const deletePilotHistory = async (id: number) => {
	return await prisma.connectedAircraft.delete({
		where: {
			id: id,
		},
	});
};

export const CheckEmailCode = async (userId: string, code: string) => {
	const user = await prisma.user.findUnique({
		where: {
			id: userId,
		},
		select: {
			emailVerificationToken: true,
			emailVerificationExpiresAt: true,
		},
	});
	if (!user) {
		return { error: "Nutzer nicht gefunden" };
	}
	if (user.emailVerificationToken !== code || !user.emailVerificationExpiresAt) {
		return { error: "Falscher Code" };
	}
	if (user.emailVerificationExpiresAt < new Date()) {
		return { error: "Code ist nicht mehr gültig" };
	}

	await prisma.user.update({
		where: {
			id: userId,
		},
		data: {
			emailVerified: true,
			emailVerificationToken: null,
			emailVerificationExpiresAt: null,
		},
	});
	return {
		message: "Email bestätigt!",
	};
};

export const sendVerificationLink = async (userId: string) => {
	const code = Math.floor(10000 + Math.random() * 90000).toString();

	const user = await prisma.user.update({
		where: {
			id: userId,
		},
		data: {
			emailVerificationToken: code,
			emailVerificationExpiresAt: new Date(Date.now() + 24 * 60 * 60 * 1000), // 24 hours
		},
	});

	await sendMailByTemplate(user.email, "email-verification", {
		user: user,
		code,
	});
};
